// Czytelnicy-pisarze - rozwizanie "klasyczne"
/*
#include <vxWorks.h>
#include <taskLib.h>
#include <sysLib.h>
#include <semLib.h>
#include <stdio.h>

void pisarz(void);
void czytelnik1(void);
void czytelnik2(void);

SEM_ID semMutex, semPis;
int liczba_czyt=0;
int shared_var=0;

void main(void)
{
	int ret1, ret2, ret3;
	// Utwrz odblokowany semafor:
	semMutex=semBCreate(SEM_Q_PRIORITY,SEM_FULL);
	semPis=semBCreate(SEM_Q_PRIORITY,SEM_FULL);
	
	ret1=taskSpawn("pisarz",100,0,4096,(FUNCPTR)pisarz,0,0,0,0,0,0,0,0,0,0);
	ret2=taskSpawn("czytelnik1",110,0,4096,(FUNCPTR)czytelnik1,0,0,0,0,0,0,0,0,0,0);
	ret3=taskSpawn("czytelnik2",110,0,4096,(FUNCPTR)czytelnik2,0,0,0,0,0,0,0,0,0,0);
	
	taskSuspend(0);
}


void pisarz(void)
{
	static int a=0;
	while(1)
	{
		printf("Pisarz a=%d\n",a);
		// Na czas wykonywania sekcji krytycznej
		// zablokj semafor, potem odblokj:
		semTake(semPis,WAIT_FOREVER);
			shared_var=a;
		semGive(semPis);
		a++;
		taskDelay(sysClkRateGet()*5);
	}
}

void czytelnik1(void)
{
	static int b=0;
	while(1)
	{
		semTake(semMutex,WAIT_FOREVER);
			liczba_czyt=liczba_czyt+1;
			if(liczba_czyt==1) semTake(semPis,WAIT_FOREVER);
		semGive(semMutex);
				
		b=shared_var;
		
		semTake(semMutex,WAIT_FOREVER);
			liczba_czyt=liczba_czyt-1;
			if(liczba_czyt==0) semGive(semPis);
		semGive(semMutex);
		
		printf("Czytelnik 1 b=%d\n",b);	
		taskDelay(sysClkRateGet()*2);
	}
}

void czytelnik2(void)
{
	static int b=0;
	while(1)
	{
		semTake(semMutex,WAIT_FOREVER);
			liczba_czyt=liczba_czyt+1;
			if(liczba_czyt==1) semTake(semPis,WAIT_FOREVER);
		semGive(semMutex);
				
		b=shared_var;
		
		semTake(semMutex,WAIT_FOREVER);
			liczba_czyt=liczba_czyt-1;
			if(liczba_czyt==0) semGive(semPis);
		semGive(semMutex);
		
		printf("Czytelnik 2 b=%d\n",b);	
		taskDelay(sysClkRateGet()*2);
	}
}
*/


// Czytelnicy-pisarze - zastosowanie 
#include <vxWorks.h>
#include <taskLib.h>
#include <sysLib.h>
#include <semLib.h>
#include <stdio.h>

void pisarz(void);
void czytelnik1(void);
void czytelnik2(void);
void czytelnik3(void);

SEM_ID semMutex;
int liczba_czyt=0;
int shared_var=0;

void main(void)
{
	int ret1, ret2, ret3, ret4;
	// Utwrz odblokowany semafor:
	semMutex=semRWCreate(SEM_Q_PRIORITY,2);
	
	
	ret1=taskSpawn("pisarz",100,0,4096,(FUNCPTR)pisarz,0,0,0,0,0,0,0,0,0,0);
	ret2=taskSpawn("czytelnik1",110,0,4096,(FUNCPTR)czytelnik1,0,0,0,0,0,0,0,0,0,0);
	ret3=taskSpawn("czytelnik2",120,0,4096,(FUNCPTR)czytelnik2,0,0,0,0,0,0,0,0,0,0);
	ret4=taskSpawn("czytelnik3",130,0,4096,(FUNCPTR)czytelnik3,0,0,0,0,0,0,0,0,0,0);
	
	taskSuspend(0);
}


void pisarz(void)
{
	static int a=0;
	while(1)
	{
		printf("Pisarz a=%d\n",a);
		// Na czas wykonywania sekcji krytycznej
		// zablokj semafor, potem odblokj:
		semWTake(semMutex,WAIT_FOREVER);
			shared_var=a;
		semGive(semMutex);
		a++;
		taskDelay(sysClkRateGet()*5);
	}
}

void czytelnik1(void)
{
	static int b=0;
	while(1)
	{
		semRTake(semMutex,WAIT_FOREVER);
			b=shared_var;
		semGive(semMutex);
				
		printf("Czytelnik 1 b=%d\n",b);	
		taskDelay(sysClkRateGet()*2);
	}
}

void czytelnik2(void)
{
	static int b=0;
	while(1)
	{
		semRTake(semMutex,WAIT_FOREVER);
			b=shared_var;
		semGive(semMutex);
						
		printf("Czytelnik 2 b=%d\n",b);	
		taskDelay(sysClkRateGet()*2);
	}
}

void czytelnik3(void)
{
	static int b=0;
	while(1)
	{
		semRTake(semMutex,WAIT_FOREVER);
			b=shared_var;
		semGive(semMutex);
						
		printf("Czytelnik 3 b=%d\n",b);	
		taskDelay(sysClkRateGet()*2);
	}
}
