/*
#include <stdio.h>

void main(void)
{
	printf("pozdrowienia");
}
*/

///////////////////////////////////////////////////////
/*ZADANIA*/
//////////////////////////////////////////////////////
/*
// Powoanie 2 niezalenych zada i upienie gwnego procesu
#include <vxWorks.h>  
#include <taskLib.h> // Zadania
#include <sysLib.h>  // Dostp do zegara
#include <stdio.h>

// Funkcja wykonywana w zadania 1:
void task1(void)
{
	static int a=0;
	while(1)
	{
		a++;
		printf("Task1\n");
		taskDelay(sysClkRateGet()*2);
	}
}

// Funkcja wykonywana w zadaniu 2:
void task2(void)
{
	static int a=0;
	while(1)
	{
		a++;
		printf("Task2\n");
		taskDelay(sysClkRateGet()*4);
	}
}

void main(void)
{
	int ret1, ret2;
	// Powoaj zadania:
	ret1=taskSpawn("task1",100,0,4096,(FUNCPTR)task1,0,0,0,0,0,0,0,0,0,0);
	ret2=taskSpawn("task1",110,0,4096,(FUNCPTR)task2,0,0,0,0,0,0,0,0,0,0);
	
	// Zawie zadanie gwne:
	taskSuspend(0);

}
*/

///////////////////////////////////////////////////////////////
/*SEMAFORY - WPROWADZENIE*/
///////////////////////////////////////////////////////////////
/*
// Synchronizacja (jedno zadanie pozwla wykonywa si drugiemu):
#include <vxWorks.h>
#include <taskLib.h>
#include <sysLib.h> 
#include <semLib.h> //Semafory
#include <stdio.h>

void task1(void);
void task2(void);

SEM_ID semMutex; // Obiekt semafora

void main(void)
{
	int ret1, ret2;
	// Utworzenie semafora od razu zablokowanego
	semMutex=semBCreate(SEM_Q_PRIORITY,SEM_EMPTY);
	ret1=taskSpawn("task1",100,0,4096,(FUNCPTR)task1,0,0,0,0,0,0,0,0,0,0);
	ret2=taskSpawn("task2",110,0,4096,(FUNCPTR)task2,0,0,0,0,0,0,0,0,0,0);
	taskSuspend(0);//zawie gwny proces
}


void task1(void)
{
	static int a=0;
	while(1)
	{
		a++;
		printf("Task1\n");
		taskDelay(sysClkRateGet()*2);
		// Odblokuj semafor:
		semGive(semMutex);
	}
}

void task2(void)
{
	static int a=0;
	while(1)
	{
		a++;
		// Czekaj na odblokowanie, zablokuj
		semTake(semMutex,WAIT_FOREVER);
		printf("Task2\n");	
	}
}
*/
/*
// Komunikacja przez wspdzielon zmienn:
#include <vxWorks.h>
#include <taskLib.h>
#include <sysLib.h>
#include <semLib.h>
#include <stdio.h>

void task1(void);
void task2(void);

SEM_ID semMutex;
int shared_var=0;

void main(void)
{
	int ret1, ret2;
	// Utwrz odblokowany semafor:
	semMutex=semBCreate(SEM_Q_PRIORITY,SEM_FULL);
	ret1=taskSpawn("task1",100,0,4096,(FUNCPTR)task1,0,0,0,0,0,0,0,0,0,0);
	ret2=taskSpawn("task2",110,0,4096,(FUNCPTR)task2,0,0,0,0,0,0,0,0,0,0);
	taskSuspend(0);
}


void task1(void)
{
	static int a=0;
	STATUS sem_ret_val;
	while(1)
	{
		a++;
		printf("a=%d\n",a);
		// Na czas wykonywania sekcji krytycznej
		// zablokj semafor, potem odblokj:
		semTake(semMutex,WAIT_FOREVER);
			shared_var=a;
		semGive(semMutex);
		taskDelay(sysClkRateGet()*2);
		semGive(semMutex);
	}
}

void task2(void)
{
	static int b=0;
	while(1)
	{
		semTake(semMutex,WAIT_FOREVER);
			b=shared_var;
		semGive(semMutex);
		printf("b=%d\n",b);	
		taskDelay(sysClkRateGet()*5);
	}
}
*/

/////////////////////////////////////////////////////
/*KOLEJKI KOMUNIKATW*/
/////////////////////////////////////////////////////
/*
// komunikacja przez kolejk
#include <vxWorks.h>
#include <taskLib.h>
#include <sysLib.h>
#include <semLib.h>
#include <msgQLib.h>  // Biblioteka z kolejkami
#include <stdio.h>
#include <string.h>   // Obsuga acuchw tekstowych
#include <errnoLib.h> // Przechwytywanie numerw bdw


void task1(void);
void task2(void);

MSG_Q_ID myMsgQId;
#define MAX_MSGS (10)
#define MAX_MSG_LEN (100)

void main(void)
{
	int ret1, ret2;
	
	// Utwrz obiekt typu kolejka:
	if((myMsgQId = msgQCreate(MAX_MSGS, 
			                  MAX_MSG_LEN,
			                  MSG_Q_PRIORITY)
	    ) != NULL)
		
	{	printf("Kolejka utworzona prawidlowo\n");	}
	else
	{	printf("Blad utworzenia kolejki\n");	}
	
		
	if((ret1=taskSpawn("task1",100,0,4096,(FUNCPTR)task1,0,0,0,0,0,0,0,0,0,0))
		!= ERROR)
	{	printf("Task1 utworzone prawidlowo\n");	}
	else
	{	printf("Blad utworzenia Task1\n");	}
		
	if((ret2=taskSpawn("task2",110,0,4096,(FUNCPTR)task2,0,0,0,0,0,0,0,0,0,0))
		!= ERROR )
	{	printf("Task2 utworzone prawidlowo\n");	}
	else
	{	printf("Blad utworzenia Task2\n");	}
			
	taskSuspend(0);
}


void task1(void)
{
	char msgBufSend[MAX_MSG_LEN]="Pozdrowienia od zadania1";
	int a=0;
	int blad=0;
	printf("Wysylam 5 komunikatow do zadania 2\n");
	while(a<5)
	{
		// Wylij komunikat do kolejki:
		if(msgQSend( myMsgQId,
					 msgBufSend,
					 strlen(msgBufSend)+1,
				     WAIT_FOREVER,
				     MSG_PRI_NORMAL)
			== ERROR)
		{
			printf("Blad wyslania danych do kolejki\n");
			blad=errnoGet();
		}
		printf("Wyslano komunikat %d\n",a+1);
		taskDelay(sysClkRateGet()*1);
		a++;
	}
}

void task2(void)
{
	char msgBufReceive[MAX_MSG_LEN];
	printf("Rozpoczecie zadania Task2\n");
	taskDelay(sysClkRateGet()*10);
	printf("Rozpoczynam odbieranie danych z kolejki\n");
	while(1)
	{	
		// Odbierz dane od koleki:
		if(msgQReceive(myMsgQId,
				       msgBufReceive,
				       MAX_MSG_LEN,
				       WAIT_FOREVER)
				== ERROR)
			{
				printf("Blad wyslania danych do kolejki\n");
			}
		printf("Wiadomosc od zadania 1:");
		puts(msgBufReceive);
		taskDelay(sysClkRateGet()*1);
	}
}
*/

/*-------------------------------------------------------------------------
Zdarzenia
-------------------------------------------------------------------------*/
//Synchronizacja na zdarzeniach:

#include <vxWorks.h>
#include <taskLib.h>
#include <sysLib.h>
#include <semLib.h>
#include <msgQLib.h>
#include <stdio.h>
#include <string.h>
#include <errnoLib.h>
#include <eventLib.h>  // Biblioteka obsugujca zdarzenia



int Task1_ID, Task2_ID; // Potrzebne globalne identyfikatory
						// zada.
void task1(void);
void task2(void);

void main(void)
{
	
	if((Task1_ID=taskSpawn("task1",100,0,4096,(FUNCPTR)task1,0,0,0,0,0,0,0,0,0,0))
		!= ERROR)
	{	printf("Task1 utworzone prawidlowo\n");	}
	else
	{	printf("Blad utworzenia Task1\n");	}
		
	if((Task2_ID=taskSpawn("task2",110,0,4096,(FUNCPTR)task2,0,0,0,0,0,0,0,0,0,0))
		!= ERROR )
	{	printf("Task2 utworzone prawidlowo\n");	}
	else
	{	printf("Blad utworzenia Task2\n");	}
			
	taskSuspend(0);
}


void task1(void)
{
	int a=0;
	int LastError=0;
	printf("Wysylam sygnaly do zadania 2\n");
	while(1)
	{
		switch(a)
		{
		case 0: case 1: case 2: case 3:case 4: case 5:
			// wylij zdarzenie:
			if(eventSend(Task2_ID,0x00000001)==ERROR)
			{
				LastError=errnoGet();
			}
			printf("Wyslano sygnal %d\n",0x1);
			break;
		default:
			if(eventSend(Task2_ID,0x00000002)==ERROR)
			{
				LastError=errnoGet();
			}
			printf("Wyslano sygnal %d\n",0x2);
			break;
		}				
		taskDelay(sysClkRateGet()*2);
		a++;
	}
}

void task2(void)
{	
	int LastError=0;
	UINT32 event;
	static int b=0;
	printf("Rozpoczecie zadania Task2\n");
	while(1)
	{	
		// Czekaj na zdarzenie:
		if(eventReceive(0x00000002,EVENTS_WAIT_ANY,WAIT_FOREVER,&event)==ERROR)
		{
				LastError=errnoGet();
		}
		eventClear();
		printf("Odebrano zdarzenie: %x\n",event);
	}
}
